# encoding: utf8
# Simulación de un resorte cuando tiene
# aplicada una fuerza y esta se quita
# Fraga, 24/11/2016
import sys
import math

# Clase Sistema Masa-Resorte-Amortiguador
class SMRA :
	def __init__( self, m, b, k, f ) : 
		self.m = m
		self.b = b
		self.k = k
		self.dt = 1.0/60.0
		self.f = f
		self.i = 0

		self.k1 = 2.0 - self.dt*b/m - self.dt*self.dt*k/m
		self.k2 = self.dt*b/m - 1.0
		self.k3 = self.dt * self.dt * f/m

		self.x = 0.0
		self.x_1 = 0.0
		self.x1 = 0.0

	def poneCondicionInicial( self, x0 ) :
		# Condición inicial
		self.x_1 = x0
		self.x = x0
		self.x1 = 0
		print "0.0", x0 
		self.i = 1

	def aplicaF( self, f ) :
		self.f = f
		self.k3 = self.dt * self.dt * self.f/self.m

	def cambia( self, x ) :
		self.x = x
		self.f = self.k * x
		self.k3 = self.dt * self.dt * self.f/self.m

	def simula( self, n ) :
		while self.i < n : 
			self.x1 = self.k1 * self.x + self.k2 * self.x_1 + self.k3
			tm = self.i * self.dt
			# print tm, self.x1
			self.x_1 = self.x
			self.x = self.x1
			self.i += 1

	

n = len( sys.argv )
if n != 2 :
	print "Args: tiempo_simulacion_(seg)"
	sys.exit(1)

seg = float( sys.argv[1] )
paro = int( 60.0*seg + 0.5 )


# Args: m, b, k, f
R = SMRA( 0.1, 0.320, 2.844, 0.0 )

y0 = 10.0
y = y0
f = y*2.844
dt = 1.0/60.0

R.poneCondicionInicial( y0 )

i = 1
t = 0
R.aplicaF( 0.0 )
while i < paro :
	R.simula( i )
	print t, R.x	
	i += 1
	t += dt

